Index: WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGRUUTL.m
===================================================================
--- WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGRUUTL.m	(revision 613)
+++ WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DGRUUTL.m	(revision 623)
@@ -1,94 +1,86 @@
-DGRUUTL	;ALB/GRR - RAI/MDS UTILITY ROUTINE ; 10/11/07 8:42am
-	;;5.3;Registration;**190,444,762**;Aug 13, 1993;Build 3
-HLNAME(DGNAME)	;Piece apart name into LAST NAME_"^"_FIRST NAME_"^"_MIDDLE NAME_"^"_SUFFIX
-	;Input DGNAME - Either Last Name, First or First, Middle and Last Name (i.e. SMITH,JOHN R   or  JOHN R SMITH)
-	S (DGFN,DGMN,DGLN,DGSUF,P1,P2,P3,P4)=""
-	I DGNAME'["," S P=$L(DGNAME," ") F Z=1:1:P S @("P"_Z)=$P(DGNAME," ",Z)
-	I DGNAME["," D
-	.S P1=$P(DGNAME,","),P2=$P(DGNAME,",",2),DGN=P2_" "_P1
-	.S P=$L(DGN," ") F Z=1:1:P S @("P"_Z)=$P(DGN," ",Z)
-	S DGSUF=$$SUF(@("P"_P))
-	I DGSUF'="" S P=P-1
-	I P=4 S DGFN=P1,DGMN=P2,DGLN=P3_" "_P4 G NAMQ
-	I P=3 D  G NAMQ
-	.I $L($P(P2,"."))=1 S DGFN=P1,DGMN=P2,DGLN=P3 Q
-	.I $L($P(P2,"."))=2 S DGFN=P1,DGLN=P2_" "_P3 Q
-	.S DGFN=P1,DGMN=P2,DGLN=P3
-	S DGFN=P1,DGLN=P2
-NAMQ	Q DGLN_"^"_DGFN_"^"_DGMN_"^"_DGSUF
-	;
-SUF(X)	;COMPARES PASSED DATA TO LIST OF SUFFIX'S AND RETURNS A FOUND SUFFIX OR NULL
-	I "^JR.^SR.^II.^III.^IV.^V.^VI.^VII.^VIII.^VIIII.^IX.^X."'[X Q ""
-	Q X
-	;
-CHKWARD(X)	;RETURNS 1 IF RAI/MDS WARD AND 0 IF NOT
-	;;Input X - Internal Entry Number of Ward in Ward file (#42)
-	;
-	Q $S(+X>0:+($$GET1^DIQ(42,X,.035,"I")),1:0)
-	;
-MEDICARE(DFN)	;Will retrieve the patient's Medicare Number and return it or return null
-	;Input - DFN patient's IEN
-	N DGSUB ;modified p-444
-	Q:DFN']"" ""  ;p-444
-	S DGSUB=$$HICN^IBCNSU1(DFN) ;p-444
-	Q:DGSUB<0 ""  ;no medicare number  p-444
-	Q DGSUB
-	;
-MEDICAID(DFN)	;Will retrieve the patient's Medicaid Number and return it or a null
-	;Input - DFN patient's IEN
-	;
-	;  Returns the medicaid information from the patient file
-	; P-762 return Medicaid number or 'N'
-	N A S A=$$GET1^DIQ(2,DFN,.383)
-	S:A="" A="N"
-	Q A
-	;
-GETAMOV(DFN)	;GET LAST ADMISSION MOVEMENT FOR A PATIENT
-	;
-	N I,J S (I,J)=""
-	S I=$O(^DGPM("ATID1",DFN,I)) Q:I="" ""
-	S J=$O(^DGPM("ATID1",DFN,I,J)) ;ien of admission movement
-	Q J
-	;
-RELATE(X)	;CONVERT FREE TEXT RELATIONSHIP TO RELATIONSHIP FILE ENTRY NUMBER AND NAME
-	N DIC,Y
-	S X=$$UPPER^HLFNC(X)
-	S X=$S(X="WIFE":"SPOUSE",X="HUSBAND":"SPOUSE",1:X)
-	S DIC="^DG(408.11,",DIC(0)="X" D ^DIC
-	S:Y<0 Y="99^OTHER" ;DEFAULT IF NOT FOUND IN FILE
-	Q Y
-	;
-ENC(DGRSEG,DGRMNMT,DGRFLN,DGRFLNM,DGROLDN,DGRNDATA,DGRSIED,DGCIEN)	;CREATE AND SEND MASTER FILE UPDATE HL7 MESSAGE
-	;INPUT:
-	;     DGRSEG  -  File Number
-	;     DGRMNMT -  Message Type (ie INSURANCE)
-	;     DGRFLN  -  Vista File Number (ie 36)
-	;     DGRFLNM -  Vista File Name (ie INSURANCE COMPANY)
-	;     DGROLDN -  Old Name value
-	;     DGRNDATA - New value (ie BLUE CROSS NH/VT)
-	;     DGRSIED -  Server Protocol IEN
-	;     DGRUHLP -  Priority of Message (ie I = Immediate)
-	;
-	Q:DGRSEG=""!(DGRMNMT="")!(DGRFLN="")!(DGRFLNM="")!(DGRNDATA="")!(DGRSIED="")  ;Quit if all parameters not passed
-	D EN^DGRUGMFU(DGRSEG,DGRMNMT,DGRFLN,DGRFLNM,DGROLDN,DGRNDATA,DGCIEN) ;Call routine which formats the Master File Update
-	I $D(^TMP($J,"DGRUGMFU",1)) D  ;If a Master File Update was created, do the following
-	.M HLA("HLS")=^TMP($J,"DGRUGMFU") ;Move global array maintaining HL7 message to local array
-	.D GENERATE^HLMA("DGRU-RAI-MFU-SERVER","LM",1,.DGRUET,"") ;Call API to generate the HL7 message
-	Q
-SENDMFU()	;Function to determine if master file updates should be sent
-	Q $P($G(^DG(43,1,"HL7")),"^",4)=1
-	;
-DOCID(X)	;Insure provider ID not greater than 6 digits
-	Q:$E(X,1,3)'="PV1" -1
-	N DGDOC,DGNIEN,IEN
-	S DGDOC=$P(X,HL("FS"),8),IEN=$P(DGDOC,$E(HL("ECH")))
-	I $L(IEN)<7 G EXITDOC
-	S DGNIEN=$E(IEN,$L(IEN)-5,$L(IEN)),$P(DGDOC,$E(HL("ECH")))=DGNIEN
-	S $P(X,HL("FS"),8)=DGDOC
-EXITDOC	Q X
-	;
-ATTDOC(X)	;get attending physician - p-762
-	N ATTPTR,ATTNAME,VAIP D IN5^VADPT S ATTPTR=$P(VAIP(18),"^",1),ATTNAME=$P(VAIP(18),"^",2) K VAIP
-	I $L(ATTPTR)>6 S ATTPTR=$E(ATTPTR,$L(ATTPTR)-5,$L(ATTPTR))
-	I $G(ATTNAME) S ATTNAME=$$HLNAME(ATTNAME)
-	Q ATTPTR_$E(HL("ECH"))_ATTNAME
+DGRUUTL ;ALB/GRR - RAI/MDS UTILITY ROUTINE
+ ;;5.3;Registration;**190,444**;Aug 13, 1993
+HLNAME(DGNAME) ;Piece apart name into LAST NAME_"^"_FIRST NAME_"^"_MIDDLE NAME_"^"_SUFFIX
+ ;Input DGNAME - Either Last Name, First or First, Middle and Last Name (i.e. SMITH,JOHN R   or  JOHN R SMITH)
+ S (DGFN,DGMN,DGLN,DGSUF,P1,P2,P3,P4)=""
+ I DGNAME'["," S P=$L(DGNAME," ") F Z=1:1:P S @("P"_Z)=$P(DGNAME," ",Z)
+ I DGNAME["," D
+ .S P1=$P(DGNAME,","),P2=$P(DGNAME,",",2),DGN=P2_" "_P1
+ .S P=$L(DGN," ") F Z=1:1:P S @("P"_Z)=$P(DGN," ",Z)
+ S DGSUF=$$SUF(@("P"_P))
+ I DGSUF'="" S P=P-1
+ I P=4 S DGFN=P1,DGMN=P2,DGLN=P3_" "_P4 G NAMQ
+ I P=3 D  G NAMQ
+ .I $L($P(P2,"."))=1 S DGFN=P1,DGMN=P2,DGLN=P3 Q
+ .I $L($P(P2,"."))=2 S DGFN=P1,DGLN=P2_" "_P3 Q
+ .S DGFN=P1,DGMN=P2,DGLN=P3
+ S DGFN=P1,DGLN=P2
+NAMQ Q DGLN_"^"_DGFN_"^"_DGMN_"^"_DGSUF
+ ;
+SUF(X) ;COMPARES PASSED DATA TO LIST OF SUFFIX'S AND RETURNS A FOUND SUFFIX OR NULL
+ I "^JR.^SR.^II.^III.^IV.^V.^VI.^VII.^VIII.^VIIII.^IX.^X."'[X Q ""
+ Q X
+ ;
+CHKWARD(X) ;RETURNS 1 IF RAI/MDS WARD AND 0 IF NOT
+ ;;Input X - Internal Entry Number of Ward in Ward file (#42)
+ ;
+ Q $S(+X>0:+($$GET1^DIQ(42,X,.035,"I")),1:0)
+ ;
+MEDICARE(DFN) ;Will retrieve the patient's Medicare Number and return it or return null
+ ;Input - DFN patient's IEN
+ N DGSUB ;modified p-444
+ Q:DFN']"" ""  ;p-444
+ S DGSUB=$$HICN^IBCNSU1(DFN) ;p-444
+ Q:DGSUB<0 ""  ;no medicare number  p-444
+ Q DGSUB
+ ;
+MEDICAID(DFN) ;Will retrieve the patient's Medicaid Number and return it or a null
+ ;Input - DFN patient's IEN
+ ;
+ ;  Returns the medicaid information from the patient file
+ Q $$GET1^DIQ(2,DFN,.383)
+ ;
+GETAMOV(DFN) ;GET LAST ADMISSION MOVEMENT FOR A PATIENT
+ ;
+ N I,J S (I,J)=""
+ S I=$O(^DGPM("ATID1",DFN,I)) Q:I="" ""
+ S J=$O(^DGPM("ATID1",DFN,I,J)) ;ien of admission movement
+ Q J
+ ;
+RELATE(X) ;CONVERT FREE TEXT RELATIONSHIP TO RELATIONSHIP FILE ENTRY NUMBER AND NAME
+ N DIC,Y
+ S X=$$UPPER^HLFNC(X)
+ S X=$S(X="WIFE":"SPOUSE",X="HUSBAND":"SPOUSE",1:X)
+ S DIC="^DG(408.11,",DIC(0)="X" D ^DIC
+ S:Y<0 Y="99^OTHER" ;DEFAULT IF NOT FOUND IN FILE
+ Q Y
+ ;
+ENC(DGRSEG,DGRMNMT,DGRFLN,DGRFLNM,DGROLDN,DGRNDATA,DGRSIED,DGCIEN) ;CREATE AND SEND MASTER FILE UPDATE HL7 MESSAGE
+ ;INPUT:
+ ;     DGRSEG  -  File Number
+ ;     DGRMNMT -  Message Type (ie INSURANCE)
+ ;     DGRFLN  -  Vista File Number (ie 36)
+ ;     DGRFLNM -  Vista File Name (ie INSURANCE COMPANY)
+ ;     DGROLDN -  Old Name value
+ ;     DGRNDATA - New value (ie BLUE CROSS NH/VT)
+ ;     DGRSIED -  Server Protocol IEN
+ ;     DGRUHLP -  Priority of Message (ie I = Immediate)
+ ;
+ Q:DGRSEG=""!(DGRMNMT="")!(DGRFLN="")!(DGRFLNM="")!(DGRNDATA="")!(DGRSIED="")  ;Quit if all parameters not passed
+ D EN^DGRUGMFU(DGRSEG,DGRMNMT,DGRFLN,DGRFLNM,DGROLDN,DGRNDATA,DGCIEN) ;Call routine which formats the Master File Update
+ I $D(^TMP($J,"DGRUGMFU",1)) D  ;If a Master File Update was created, do the following
+ .M HLA("HLS")=^TMP($J,"DGRUGMFU") ;Move global array maintaining HL7 message to local array
+ .D GENERATE^HLMA("DGRU-RAI-MFU-SERVER","LM",1,.DGRUET,"") ;Call API to generate the HL7 message
+ Q
+SENDMFU() ;Function to determine if master file updates should be sent
+ Q $P($G(^DG(43,1,"HL7")),"^",4)=1
+ ;
+DOCID(X) ;Insure provider ID not greater than 6 digits
+ Q:$E(X,1,3)'="PV1" -1
+ N DGDOC,DGNIEN,IEN
+ S DGDOC=$P(X,HL("FS"),8),IEN=$P(DGDOC,$E(HL("ECH")))
+ I $L(IEN)<7 G EXITDOC
+ S DGNIEN=$E(IEN,$L(IEN)-5,$L(IEN)),$P(DGDOC,$E(HL("ECH")))=DGNIEN
+ S $P(X,HL("FS"),8)=DGDOC
+EXITDOC Q X
+ ;
Index: WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DPTLK.m
===================================================================
--- WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DPTLK.m	(revision 613)
+++ WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/DPTLK.m	(revision 623)
@@ -1,233 +1,233 @@
-DPTLK	;ALB/RMO,RTK - MAS Patient Look-up Main Routine ;1/27/07  13:12
-	;;5.3;Registration;**32,72,93,73,136,157,197,232,265,277,223,327,244,513,528,541,576,600,485,633,629,647,634**;Aug 13, 1993;Build 30
-	; Modified from FOIA VISTA,
-	; Copyright (C) 2007 WorldVistA
-	;
-	; This program is free software; you can redistribute it and/or modify
-	; it under the terms of the GNU General Public License as published by
-	; the Free Software Foundation; either version 2 of the License, or
-	; (at your option) any later version.
-	;
-	;
-	; mods made for magstripe read 12/96 - JFP
-	;
-	;Optional input: DPTNOFZY='1' to suppress fuzzy lookups implemented
-	;                by patch DG*5.3*244
-	;
-EN	; -- Entry point
-	;Following line so VOE will use alternate lookup routine, DAOU,VA/CJS,WV/TOAD
-	I $G(DUZ("AG"))'="V" D ^AUPNLK Q
-	N DIE,DR
-	K DPTX,DPTDFN,DPTSAVX I $D(DIC(0)) G QK:DIC(0)["I"!(DIC(0)'["A"&('$D(X)))
-	I '$D(^DD("VERSION")) W !!?3,"Unable to proceed. Fileman version node ^DD(""VERSION"") is undefined." G QK
-	I '$D(^DPT(0))!(^DD("VERSION")<17.2) W !!?3,"Unable to proceed. ",$S('$D(^DPT(0)):"0th node of ^DPT missing",^DD("VERSION")<17.2:"Fileman version must be at least 17.2",1:""),"." G QK
-EN2	K DO,DUOUT,DTOUT S U="^",DIC="^DPT(",DIC(0)=$S($D(DIC(0)):DIC(0),1:"AELMQ") S:DIC(0)'["A" (DPTX,DPTSAVX)=X
-	S DPTSZ=1000 I $D(^DD("OS"))#2 S DPTSZ=$S(+$P(^DD("OS",^("OS"),0),U,2):$P(^(0),U,2),1:DPTSZ)
-	;
-ASKPAT	; -- Prompt for patient
-	I DIC(0)["A" D   G QK:'$T!($E(DPTX)["^")!(DPTX="")
-	.K DTOUT,DUOUT
-	.W !,$S($D(DIC("A")):DIC("A"),1:"Select PATIENT NAME: ") W:$D(DIC("B")) DIC("B"),"// "
-	.R X:DTIME
-	.S DPTX=X S:'$T DTOUT=1 S:$T&(DPTX="")&($D(DIC("B"))) DPTX=DIC("B") S:DPTX["^"&($E(DPTX)'="%") DUOUT=1
-	; -- Check for the IATA magnetic stripe input
-	N MAG,GCHK
-	S MAG=0
-	I $E(DPTX)="%"!($E(DPTX)=";"),DPTX["?" S MAG=1,(X,DPTX)=$$IATA(DPTX)
-	;
-CHKPAT	; -- Custom Patient Lookup
-	D DO^DIC1
-	S DIC("W")=$S($D(DIC("W")):DIC("W"),1:"")
-	K DPTIFNS,DPTS,DPTSEL
-	S DPTCNT=0
-	; -- Check input for format an length
-	G CHKDFN:DPTX?1A!(DPTX'?.ANP)!($L(DPTX)>30)
-	; -- Check for null response or abort
-	I DPTX=""!(DPTX["^") G ASKPAT:DIC(0)["A",QK
-	; -- Check for question mark
-	I DPTX["?" D  G ASKPAT:DIC(0)["A",QK
-	.S D="B"
-	.S DZ=$S(DPTX?1"?":"",1:"??")
-	.G CHKPAT1:DZ="??"
-	.N %
-	.W !,?1,"Answer with PATIENT NAME, or SOCIAL SECURITY NUMBER, or last 4 digits",!,?4,"of SOCIAL SECURITY NUMBER, or first initial of"
-	.W " last name with last",!,?4,"4 digits of SOCIAL SECURITY NUMBER"
-	.W !,?1,"Do you want the entire ",+$P($G(^DPT(0)),"^",4),"-Entry PATIENT List" S %=0 D YN^DICN
-	.Q:%'=1
-	.S DZ="??"
-CHKPAT1	.S X=DPTX
-	.D DQ^DICQ
-	; -- Check for space bar, return
-	I DPTX=" " D  G CHKDFN
-	.S Y=$S('($D(DUZ)#2):-1,$D(^DISV(DUZ,"^DPT(")):^("^DPT("),1:-1)
-	.D SETDPT^DPTLK1:Y>0
-	.S DPTDFN=$S($D(DPTS(Y)):Y,1:-1)
-	; -- Check for DFN look up
-	I $E(DPTX)="`" D  G CHKDFN
-	.S Y=$S($D(^DPT(+$P(DPTX,"`",2),0)):+$P(DPTX,"`",2),1:-1)
-	.D SETDPT^DPTLK1:Y>0
-	.S DPTDFN=$S($D(DPTS(Y)):Y,1:-1)
-	; -- Puts input in correct format
-	G CHKDFN:DPTX=""
-	; -- Force new entry
-	I $E(DPTX)="""",$E(DPTX,$L(DPTX))="""" G NOPAT
-	; -- Check for index lookups
-	D ^DPTLK1 G QK:$D(DTOUT)!($D(DUOUT)&(DIC(0)'["A")),ASKPAT:$D(DUOUT),CHKPAT:DPTDFN<0,CHKDFN:DPTDFN>0 I DIC(0)["N",$D(^DPT(DPTX,0)) S Y=X D SETDPT^DPTLK1 S DPTDFN=$S($D(DPTS(Y)):Y,1:-1) G CHKDFN
-MAG	; -- No patient found, check for mag stripe input, create stub
-	I 'MAG G NOPAT
-	; -- Check for ADT option(s) only
-	N DGOPT
-	S DGOPT=$P($G(XQY0),"^",2)
-	I DGOPT'="Load/Edit Patient Data",DGOPT'="Register a Patient" D  G EN2
-	.W !,"    ...Patient not in database, use ADT options to load patient" D Q1
-	; -- Prompt for creation of stub
-	S DIR(0)="Y",DIR("B")="NO",DIR("A")="Patient not found...Create stub entry: "
-	S GCHK=$D(^TMP("DGVIC"))
-	D ^DIR
-	K DIR
-	I 'Y D Q1 G EN2
-	; -- Parse IATA fields
-	D FIELDS(IATA)
-	; -- Check for Duplicates
-	D EP2^DPTLK3
-	I DPTDFN<0 D Q1 G EN2
-	; -- Creates Stub entry in patient file
-	S Y=$$FILE^DPTLK4(DGFLDS)
-	I $P(Y,"^",3)'=1 W !,"Could not add patient to patient file" D QK1 Q
-	D QK1
-	Q
-	;
-NOPAT	; -- No patient found, ask to add new
-	I DIC(0)["L" D ^DPTLK2 S Y=DPTDFN G ASKPAT:DIC(0)["A"&(Y<0)&('$G(DTOUT)),QK1
-	;
-CHKDFN	; -- 
-	S:'$D(DPTDFN) DPTDFN=-1 I DPTDFN'>0!('$D(DPTS(+DPTDFN))) W:DIC(0)["Q" *7," ??" G ASKPAT:DIC(0)["A",QK
-	I DIC(0)["E" D  W $S('$D(DPTSEL)&('$D(DIVP)):$P(DPTS(DPTDFN),U,2)_"  "_$P(DPTS(DPTDFN),U)_"  ",$D(^DPT(DPTDFN,0)):"  "_$P(^(0),U)_"  ",1:"") S Y=DPTDFN X:$D(^DPT(DPTDFN,0)) "N DDS X DIC(""W"")"
-	.I $D(DDS) D CLRMSG^DDS S DX=0,DY=DDSHBX+1 X DDXY
-	;
-	; check for other patients in "BS5" xref on Patient file
-	I '$G(DICR),DPTDFN>0,DIC(0)["E",$$BS5^DPTLK5(+DPTDFN) D  G ASKPAT:DIC(0)["A"&(%'=1),QK:DPTDFN<0
-	.N DPTZERO,DPTLSNME,DPTSSN S DPTZERO=$G(^DPT(+DPTDFN,0)),DPTLSNME=$P($P(DPTZERO,U),","),DPTSSN=$E($P(DPTZERO,U,9),6,9)
-	.W $C(7),!!,"There is more than one patient whose last name is '",DPTLSNME,"' and"
-	.W !,"whose social security number ends with '",DPTSSN,"'."
-	.W !,"Are you sure you wish to continue (Y/N)" S %=0 D YN^DICN
-	.I %'=1 S DPTDFN=-1
-	;
-	I '$G(DICR),DPTDFN>0 S Y=DPTDFN D ^DGSEC S DPTDFN=Y G ASKPAT:DIC(0)["A"&(DPTDFN<0),QK:DPTDFN<0
-	S DPTX=DPTX_$P(DPTS(DPTDFN),U,2),DPTDFN=DPTDFN_U_$P(^DPT(DPTDFN,0),U)
-	;
-Q	; -- 
-	S Y=$S('$D(DPTDFN):-1,'$D(DPTS(+DPTDFN)):-1,1:DPTDFN),X=$S($D(DPTX)&(+Y>0):DPTX,$D(DPTSAVX):DPTSAVX,$D(DPTX):DPTX,1:"")
-	I Y>0 S:DIC(0)'["F" ^DISV($S($D(DUZ)#2:DUZ,1:0),"^DPT(")=+Y S:DIC(0)["Z" Y(0)=^DPT(+Y,0),Y(0,0)=$P(^(0),U,1)
-	;DG*600
-	;I DIC(0)["E",$P($G(^DPT(+Y,0)),U,21) W *7,!,"Warning : You have selected a test patient."
-	I DIC(0)["E",$$TESTPAT^VADPT(+Y) W *7,!,"WARNING : You may have selected a test patient."
-	I DIC(0)["E",$$BADADR^DGUTL3(+Y) W *7,!,"WARNING : ** This patient has been flagged with a Bad Address Indicator."
-	I DIC(0)["E",$$VAADV^DPTLK3(+Y) W *7,!,"** Patient is VA ADVANTAGE."
-	;DG*485
-	I $D(^DPT("AXFFP",1,+Y)) D FFP^DPTLK5
-	;Display enrollment information
-	I Y>0,DIC(0)["E" D ENR
-	;
-	;Call Combat Vet check
-	I Y>0,DIC(0)["E" D CV
-	;
-	; check whether to display Means Test Required message
-	D
-	.N DPTDIV
-	.I '$G(DUZ(2)) Q
-	.I Y>0,DIC(0)["E" S DPTDIV=$$DMT^DPTLK5(+Y,DUZ(2)) I DPTDIV D
-	..W $C(7),!!,"MEANS TEST REQUIRED"
-	..W !,?3,$P($G(^DG(40.8,DPTDIV,"MT")),U,2)
-	..H 2
-	;
-Q1	; -- Clean up variables
-	K D,DIC("W"),DO,DPTCNT,DPTDFN,DPTIFNS,DPTIX,DPTS
-	K DPTSAVX,DPTSEL,DPTSZ,DPTX
-	;
-	K:$D(IATA) IATA
-	K:$D(DGFLDS) @DGFLDS,DGFLDS
-	Q
-	;
-QK	K:'$D(DPTNOFZK) DPTNOFZY G Q
-	;
-QK1	K:'$D(DPTNOFZK) DPTNOFZY G Q1
-	;
-IX	; --
-	I $D(D),$D(^DD(2,0,"IX",D)),($E(D)'="A") S DPTIX=D
-	G DPTLK
-	;
-IATA(X)	; --
-	;This function pulls off ssn from the IATA track
-	;
-	;Input:  X   -  what was read in
-	;Output: SSN -  social security number
-	;          Q -  quit
-	;
-	; Track            Start Sent     End Sent      Field Separator
-	; -----            ----------     --------      ---------------
-	;  IATA (alphanum)      %             ?          {   (Note: VA used ^)
-	;  ABA (numeric)        ;             ?          =    
-	;
-	;N IATA
-	S (IATA)=""
-	I $E(X)'="%" Q X ; no start sentinel
-	I X'["?" Q "Q"
-	; -- Extract data from track
-	S IATA=$$TRACK(X,"%","?")
-	; -- checks for no data
-	I IATA="" Q "Q"
-	; -- Returns SSN
-	I IATA'="" Q $P(IATA,"^")
-	Q "Q"
-	;
-TRACK(X,START,END)	; find track where start/end are sentinels
-	;
-	Q $P($P($G(X),START,2),END,1)
-	;
-FIELDS(IATA)	; -- Sets fields
-	Q:'$D(IATA)
-	N CNT,FIELD
-	S DGFLDS="^TMP(""DGVIC"","_$J_")",CNT=1
-	K @DGFLDS
-	F  S FIELD=$P($G(IATA),"^",CNT)  Q:FIELD=""  D
-	.S @DGFLDS@(CNT)=FIELD
-	.S CNT=CNT+1
-	; -- Define fields for duplicate checker
-	S DPTX=$G(@DGFLDS@(2)) ;NAME
-	S DPTIDS(.03)=$G(@DGFLDS@(3)) ;DOB
-	S DPTIDS(.09)=$G(@DGFLDS@(1)) ;SSN
-	Q
-ENR	;Display Enrollment information after patient selection
-	N DGENCAT,DGENDFN,DGENR,DGEGTIEN,DGEGT
-	I '$$GET^DGENA($$FINDCUR^DGENA(+DPTDFN),.DGENR) Q
-	S DGENCAT=$$CATEGORY^DGENA4(+DPTDFN)
-	S DGENCAT=$$EXTERNAL^DILFD(27.15,.02,"",DGENCAT)
-	W !?1,"Enrollment Priority: ",$S($G(DGENR("PRIORITY")):$$EXT^DGENU("PRIORITY",DGENR("PRIORITY")),1:""),$S($G(DGENR("SUBGRP"))="":"",1:$$EXT^DGENU("SUBGRP",$G(DGENR("SUBGRP"))))
-	W ?33,"Category: ",DGENCAT
-	W ?57,"End Date: ",$S($G(DGENR("END")):$$FMTE^XLFDT(DGENR("END"),"5DZ"),1:""),!
-	;If patient is NOT ELIGIBLE, display Enrollment Status (Ineligible Project Phase I)
-	I $G(DGENR("STATUS"))=10!($G(DGENR("STATUS"))=19)!($G(DGENR("STATUS"))=20) D
-	. W ?1,"Enrollment Status: ",$S($G(DGENR("STATUS")):$$EXT^DGENU("STATUS",DGENR("STATUS")),1:"") ;H 5
-	;check for Combat Veteran Eligibility, if elig do not display EGT info
-	I $$CVEDT^DGCV(+DPTDFN) Q
-	;Get Enrollment Group Threshold Priority and Subgroup
-	S DGEGTIEN=$$FINDCUR^DGENEGT
-	S DGEGT=$$GET^DGENEGT(DGEGTIEN,.DGEGT)
-	Q:$G(DGENR("PRIORITY"))=""!($G(DGEGT("PRIORITY"))="")
-	;Compare Patient's Enrollment Priority to Enrollment Group Threshold
-	I '$$ABOVE^DGENEGT1(+DPTDFN,DGENR("PRIORITY"),$G(DGENR("SUBGRP")),DGEGT("PRIORITY"),DGEGT("SUBGRP")) D
-	.N X,IORVOFF,IORVON
-	.S X="IORVOFF;IORVON"
-	.D ENDR^%ZISS
-	.W !?32 W:$D(IORVON) IORVON  W "*** WARNING ***" W:$D(IORVOFF) IORVOFF
-	.I DGENR("END")'="" W !?14 W:$D(IORVON) IORVON W "*** PATIENT ENROLLMENT END",$S(DT>+DGENR("END"):"ED",1:"S")," EFFECTIVE ",$$FMTE^XLFDT(DGENR("END"),"5DZ")," ***" W:$D(IORVOFF) IORVOFF Q
-	.W !?5 W:$D(IORVON) IORVON W "*** PATIENT ENROLLMENT ENDING.  ENROLLMENT END DATE IS NOT KNOWN. ***" W:$D(IORVOFF) IORVOFF
-	Q
-CV	;check for Combat Vet status
-	N DGCV
-	S DGCV=$$CVEDT^DGCV(+DPTDFN)
-	I $P(DGCV,U)=1 D  Q
-	. I '$$GET^DGENA($$FINDCUR^DGENA(+DPTDFN),.DGENR) W !
-	. W ?3,"Combat Vet Status: "_$S($P(DGCV,U,3)=1:"ELIGIBLE",1:"EXPIRED"),?57,"End Date: "_$$FMTE^XLFDT($P(DGCV,U,2),"5DZ")
-	Q
+DPTLK ;ALB/RMO,RTK - MAS Patient Look-up Main Routine ;1/27/07  13:12
+ ;;5.3;Registration;**32,72,93,73,136,157,197,232,265,277,223,327,244,513,528,541,576,600,485,633,629,647,634**;Aug 13, 1993;Build 28
+ ; Modified from FOIA VISTA,
+ ; Copyright (C) 2007 WorldVistA
+ ;
+ ; This program is free software; you can redistribute it and/or modify
+ ; it under the terms of the GNU General Public License as published by
+ ; the Free Software Foundation; either version 2 of the License, or
+ ; (at your option) any later version.
+ ;
+ ;
+ ; mods made for magstripe read 12/96 - JFP
+ ;
+ ;Optional input: DPTNOFZY='1' to suppress fuzzy lookups implemented
+ ;                by patch DG*5.3*244
+ ;
+EN ; -- Entry point
+ ;Following line so VOE will use alternate lookup routine, DAOU,VA/CJS,WV/TOAD
+ I $G(DUZ("AG"))'="V" D ^AUPNLK Q
+ N DIE,DR
+ K DPTX,DPTDFN,DPTSAVX I $D(DIC(0)) G QK:DIC(0)["I"!(DIC(0)'["A"&('$D(X)))
+ I '$D(^DD("VERSION")) W !!?3,"Unable to proceed. Fileman version node ^DD(""VERSION"") is undefined." G QK
+ I '$D(^DPT(0))!(^DD("VERSION")<17.2) W !!?3,"Unable to proceed. ",$S('$D(^DPT(0)):"0th node of ^DPT missing",^DD("VERSION")<17.2:"Fileman version must be at least 17.2",1:""),"." G QK
+EN2 K DO,DUOUT,DTOUT S U="^",DIC="^DPT(",DIC(0)=$S($D(DIC(0)):DIC(0),1:"AELMQ") S:DIC(0)'["A" (DPTX,DPTSAVX)=X
+ S DPTSZ=1000 I $D(^DD("OS"))#2 S DPTSZ=$S(+$P(^DD("OS",^("OS"),0),U,2):$P(^(0),U,2),1:DPTSZ)
+ ;
+ASKPAT ; -- Prompt for patient
+ I DIC(0)["A" D   G QK:'$T!($E(DPTX)["^")!(DPTX="")
+ .K DTOUT,DUOUT
+ .W !,$S($D(DIC("A")):DIC("A"),1:"Select PATIENT NAME: ") W:$D(DIC("B")) DIC("B"),"// "
+ .R X:DTIME
+ .S DPTX=X S:'$T DTOUT=1 S:$T&(DPTX="")&($D(DIC("B"))) DPTX=DIC("B") S:DPTX["^"&($E(DPTX)'="%") DUOUT=1
+ ; -- Check for the IATA magnetic stripe input
+ N MAG,GCHK
+ S MAG=0
+ I $E(DPTX)="%"!($E(DPTX)=";"),DPTX["?" S MAG=1,(X,DPTX)=$$IATA(DPTX)
+ ;
+CHKPAT ; -- Custom Patient Lookup
+ D DO^DIC1
+ S DIC("W")=$S($D(DIC("W")):DIC("W"),1:"")
+ K DPTIFNS,DPTS,DPTSEL
+ S DPTCNT=0
+ ; -- Check input for format an length
+ G CHKDFN:DPTX?1A!(DPTX'?.ANP)!($L(DPTX)>30)
+ ; -- Check for null response or abort
+ I DPTX=""!(DPTX["^") G ASKPAT:DIC(0)["A",QK
+ ; -- Check for question mark
+ I DPTX["?" D  G ASKPAT:DIC(0)["A",QK
+ .S D="B"
+ .S DZ=$S(DPTX?1"?":"",1:"??")
+ .G CHKPAT1:DZ="??"
+ .N %
+ .W !,?1,"Answer with PATIENT NAME, or SOCIAL SECURITY NUMBER, or last 4 digits",!,?4,"of SOCIAL SECURITY NUMBER, or first initial of"
+ .W " last name with last",!,?4,"4 digits of SOCIAL SECURITY NUMBER"
+ .W !,?1,"Do you want the entire ",+$P($G(^DPT(0)),"^",4),"-Entry PATIENT List" S %=0 D YN^DICN
+ .Q:%'=1
+ .S DZ="??"
+CHKPAT1 .S X=DPTX
+ .D DQ^DICQ
+ ; -- Check for space bar, return
+ I DPTX=" " D  G CHKDFN
+ .S Y=$S('($D(DUZ)#2):-1,$D(^DISV(DUZ,"^DPT(")):^("^DPT("),1:-1)
+ .D SETDPT^DPTLK1:Y>0
+ .S DPTDFN=$S($D(DPTS(Y)):Y,1:-1)
+ ; -- Check for DFN look up
+ I $E(DPTX)="`" D  G CHKDFN
+ .S Y=$S($D(^DPT(+$P(DPTX,"`",2),0)):+$P(DPTX,"`",2),1:-1)
+ .D SETDPT^DPTLK1:Y>0
+ .S DPTDFN=$S($D(DPTS(Y)):Y,1:-1)
+ ; -- Puts input in correct format
+ G CHKDFN:DPTX=""
+ ; -- Force new entry
+ I $E(DPTX)="""",$E(DPTX,$L(DPTX))="""" G NOPAT
+ ; -- Check for index lookups
+ D ^DPTLK1 G QK:$D(DTOUT)!($D(DUOUT)&(DIC(0)'["A")),ASKPAT:$D(DUOUT),CHKPAT:DPTDFN<0,CHKDFN:DPTDFN>0 I DIC(0)["N",$D(^DPT(DPTX,0)) S Y=X D SETDPT^DPTLK1 S DPTDFN=$S($D(DPTS(Y)):Y,1:-1) G CHKDFN
+MAG ; -- No patient found, check for mag stripe input, create stub
+ I 'MAG G NOPAT
+ ; -- Check for ADT option(s) only
+ N DGOPT
+ S DGOPT=$P($G(XQY0),"^",2)
+ I DGOPT'="Load/Edit Patient Data",DGOPT'="Register a Patient" D  G EN2
+ .W !,"    ...Patient not in database, use ADT options to load patient" D Q1
+ ; -- Prompt for creation of stub
+ S DIR(0)="Y",DIR("B")="NO",DIR("A")="Patient not found...Create stub entry: "
+ S GCHK=$D(^TMP("DGVIC"))
+ D ^DIR
+ K DIR
+ I 'Y D Q1 G EN2
+ ; -- Parse IATA fields
+ D FIELDS(IATA)
+ ; -- Check for Duplicates
+ D EP2^DPTLK3
+ I DPTDFN<0 D Q1 G EN2
+ ; -- Creates Stub entry in patient file
+ S Y=$$FILE^DPTLK4(DGFLDS)
+ I $P(Y,"^",3)'=1 W !,"Could not add patient to patient file" D QK1 Q
+ D QK1
+ Q
+ ;
+NOPAT ; -- No patient found, ask to add new
+ I DIC(0)["L" D ^DPTLK2 S Y=DPTDFN G ASKPAT:DIC(0)["A"&(Y<0)&('$G(DTOUT)),QK1
+ ;
+CHKDFN ; -- 
+ S:'$D(DPTDFN) DPTDFN=-1 I DPTDFN'>0!('$D(DPTS(+DPTDFN))) W:DIC(0)["Q" *7," ??" G ASKPAT:DIC(0)["A",QK
+ I DIC(0)["E" D  W $S('$D(DPTSEL)&('$D(DIVP)):$P(DPTS(DPTDFN),U,2)_"  "_$P(DPTS(DPTDFN),U)_"  ",$D(^DPT(DPTDFN,0)):"  "_$P(^(0),U)_"  ",1:"") S Y=DPTDFN X:$D(^DPT(DPTDFN,0)) "N DDS X DIC(""W"")"
+ .I $D(DDS) D CLRMSG^DDS S DX=0,DY=DDSHBX+1 X DDXY
+ ;
+ ; check for other patients in "BS5" xref on Patient file
+ I '$G(DICR),DPTDFN>0,DIC(0)["E",$$BS5^DPTLK5(+DPTDFN) D  G ASKPAT:DIC(0)["A"&(%'=1),QK:DPTDFN<0
+ .N DPTZERO,DPTLSNME,DPTSSN S DPTZERO=$G(^DPT(+DPTDFN,0)),DPTLSNME=$P($P(DPTZERO,U),","),DPTSSN=$E($P(DPTZERO,U,9),6,9)
+ .W $C(7),!!,"There is more than one patient whose last name is '",DPTLSNME,"' and"
+ .W !,"whose social security number ends with '",DPTSSN,"'."
+ .W !,"Are you sure you wish to continue (Y/N)" S %=0 D YN^DICN
+ .I %'=1 S DPTDFN=-1
+ ;
+ I '$G(DICR),DPTDFN>0 S Y=DPTDFN D ^DGSEC S DPTDFN=Y G ASKPAT:DIC(0)["A"&(DPTDFN<0),QK:DPTDFN<0
+ S DPTX=DPTX_$P(DPTS(DPTDFN),U,2),DPTDFN=DPTDFN_U_$P(^DPT(DPTDFN,0),U)
+ ;
+Q ; -- 
+ S Y=$S('$D(DPTDFN):-1,'$D(DPTS(+DPTDFN)):-1,1:DPTDFN),X=$S($D(DPTX)&(+Y>0):DPTX,$D(DPTSAVX):DPTSAVX,$D(DPTX):DPTX,1:"")
+ I Y>0 S:DIC(0)'["F" ^DISV($S($D(DUZ)#2:DUZ,1:0),"^DPT(")=+Y S:DIC(0)["Z" Y(0)=^DPT(+Y,0),Y(0,0)=$P(^(0),U,1)
+ ;DG*600
+ ;I DIC(0)["E",$P($G(^DPT(+Y,0)),U,21) W *7,!,"Warning : You have selected a test patient."
+ I DIC(0)["E",$$TESTPAT^VADPT(+Y) W *7,!,"WARNING : You may have selected a test patient."
+ I DIC(0)["E",$$BADADR^DGUTL3(+Y) W *7,!,"WARNING : ** This patient has been flagged with a Bad Address Indicator."
+ I DIC(0)["E",$$VAADV^DPTLK3(+Y) W *7,!,"** Patient is VA ADVANTAGE."
+ ;DG*485
+ I $D(^DPT("AXFFP",1,+Y)) D FFP^DPTLK5
+ ;Display enrollment information
+ I Y>0,DIC(0)["E" D ENR
+ ;
+ ;Call Combat Vet check
+ I Y>0,DIC(0)["E" D CV
+ ;
+ ; check whether to display Means Test Required message
+ D
+ .N DPTDIV
+ .I '$G(DUZ(2)) Q
+ .I Y>0,DIC(0)["E" S DPTDIV=$$DMT^DPTLK5(+Y,DUZ(2)) I DPTDIV D
+ ..W $C(7),!!,"MEANS TEST REQUIRED"
+ ..W !,?3,$P($G(^DG(40.8,DPTDIV,"MT")),U,2)
+ ..H 2
+ ;
+Q1 ; -- Clean up variables
+ K D,DIC("W"),DO,DPTCNT,DPTDFN,DPTIFNS,DPTIX,DPTS
+ K DPTSAVX,DPTSEL,DPTSZ,DPTX
+ ;
+ K:$D(IATA) IATA
+ K:$D(DGFLDS) @DGFLDS,DGFLDS
+ Q
+ ;
+QK K:'$D(DPTNOFZK) DPTNOFZY G Q
+ ;
+QK1 K:'$D(DPTNOFZK) DPTNOFZY G Q1
+ ;
+IX ; --
+ I $D(D),$D(^DD(2,0,"IX",D)),($E(D)'="A") S DPTIX=D
+ G DPTLK
+ ;
+IATA(X) ; --
+ ;This function pulls off ssn from the IATA track
+ ;
+ ;Input:  X   -  what was read in
+ ;Output: SSN -  social security number
+ ;          Q -  quit
+ ;
+ ; Track            Start Sent     End Sent      Field Separator
+ ; -----            ----------     --------      ---------------
+ ;  IATA (alphanum)      %             ?          {   (Note: VA used ^)
+ ;  ABA (numeric)        ;             ?          =    
+ ;
+ ;N IATA
+ S (IATA)=""
+ I $E(X)'="%" Q X ; no start sentinel
+ I X'["?" Q "Q"
+ ; -- Extract data from track
+ S IATA=$$TRACK(X,"%","?")
+ ; -- checks for no data
+ I IATA="" Q "Q"
+ ; -- Returns SSN
+ I IATA'="" Q $P(IATA,"^")
+ Q "Q"
+ ;
+TRACK(X,START,END) ; find track where start/end are sentinels
+ ;
+ Q $P($P($G(X),START,2),END,1)
+ ;
+FIELDS(IATA) ; -- Sets fields
+ Q:'$D(IATA)
+ N CNT,FIELD
+ S DGFLDS="^TMP(""DGVIC"","_$J_")",CNT=1
+ K @DGFLDS
+ F  S FIELD=$P($G(IATA),"^",CNT)  Q:FIELD=""  D
+ .S @DGFLDS@(CNT)=FIELD
+ .S CNT=CNT+1
+ ; -- Define fields for duplicate checker
+ S DPTX=$G(@DGFLDS@(2)) ;NAME
+ S DPTIDS(.03)=$G(@DGFLDS@(3)) ;DOB
+ S DPTIDS(.09)=$G(@DGFLDS@(1)) ;SSN
+ Q
+ENR ;Display Enrollment information after patient selection
+ N DGENCAT,DGENDFN,DGENR,DGEGTIEN,DGEGT
+ I '$$GET^DGENA($$FINDCUR^DGENA(+DPTDFN),.DGENR) Q
+ S DGENCAT=$$CATEGORY^DGENA4(+DPTDFN)
+ S DGENCAT=$$EXTERNAL^DILFD(27.15,.02,"",DGENCAT)
+ W !?1,"Enrollment Priority: ",$S($G(DGENR("PRIORITY")):$$EXT^DGENU("PRIORITY",DGENR("PRIORITY")),1:""),$S($G(DGENR("SUBGRP"))="":"",1:$$EXT^DGENU("SUBGRP",$G(DGENR("SUBGRP"))))
+ W ?33,"Category: ",DGENCAT
+ W ?57,"End Date: ",$S($G(DGENR("END")):$$FMTE^XLFDT(DGENR("END"),"5DZ"),1:""),!
+ ;If patient is NOT ELIGIBLE, display Enrollment Status (Ineligible Project Phase I)
+ I $G(DGENR("STATUS"))=10!($G(DGENR("STATUS"))=19)!($G(DGENR("STATUS"))=20) D
+ . W ?1,"Enrollment Status: ",$S($G(DGENR("STATUS")):$$EXT^DGENU("STATUS",DGENR("STATUS")),1:"") ;H 5
+ ;check for Combat Veteran Eligibility, if elig do not display EGT info
+ I $$CVEDT^DGCV(+DPTDFN) Q
+ ;Get Enrollment Group Threshold Priority and Subgroup
+ S DGEGTIEN=$$FINDCUR^DGENEGT
+ S DGEGT=$$GET^DGENEGT(DGEGTIEN,.DGEGT)
+ Q:$G(DGENR("PRIORITY"))=""!($G(DGEGT("PRIORITY"))="")
+ ;Compare Patient's Enrollment Priority to Enrollment Group Threshold
+ I '$$ABOVE^DGENEGT1(+DPTDFN,DGENR("PRIORITY"),$G(DGENR("SUBGRP")),DGEGT("PRIORITY"),DGEGT("SUBGRP")) D
+ .N X,IORVOFF,IORVON
+ .S X="IORVOFF;IORVON"
+ .D ENDR^%ZISS
+ .W !?32 W:$D(IORVON) IORVON  W "*** WARNING ***" W:$D(IORVOFF) IORVOFF
+ .I DGENR("END")'="" W !?14 W:$D(IORVON) IORVON W "*** PATIENT ENROLLMENT END",$S(DT>+DGENR("END"):"ED",1:"S")," EFFECTIVE ",$$FMTE^XLFDT(DGENR("END"),"5DZ")," ***" W:$D(IORVOFF) IORVOFF Q
+ .W !?5 W:$D(IORVON) IORVON W "*** PATIENT ENROLLMENT ENDING.  ENROLLMENT END DATE IS NOT KNOWN. ***" W:$D(IORVOFF) IORVOFF
+ Q
+CV ;check for Combat Vet status
+ N DGCV
+ S DGCV=$$CVEDT^DGCV(+DPTDFN)
+ I $P(DGCV,U)=1 D  Q
+ . I '$$GET^DGENA($$FINDCUR^DGENA(+DPTDFN),.DGENR) W !
+ . W ?3,"Combat Vet Status: "_$S($P(DGCV,U,3)=1:"ELIGIBLE",1:"EXPIRED"),?57,"End Date: "_$$FMTE^XLFDT($P(DGCV,U,2),"5DZ")
+ Q
Index: WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VADATE.m
===================================================================
--- WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VADATE.m	(revision 613)
+++ WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VADATE.m	(revision 623)
@@ -1,16 +1,16 @@
-VADATE	;ALB/MLI - GENERIC DATE ROUTINE ; 1 DEC 88 @1000
-	;;5.3;Registration,;**749**;Aug 13, 1993;Build 10
-	;
-	I $D(VADAT("F")),$S(VADAT("F")<1:1,VADAT("F")>2:1,1:0) K VADAT("F")
-	I '$D(VADAT("W")) S VANOW=$$NOW^XLFDT
-	S VA=$S('$D(VADAT("W")):VANOW,1:VADAT("W")),(VA,VADATE("I"))=$S($D(VADAT("S")):VA,'$D(VADAT("T")):$E(VA,1,12),1:$P(VA,".",1))
-	S:'$D(VADAT("H")) (VA(1),VA(2),VA(3))=1 I $D(VADAT("H")) F I=1:1:3 S VA(I)=$S(VADAT("H")[I:1,1:0)
-	S VAM=$S('$E(VA,4,5):"",'VA(2):"",$S('$D(VADAT("F")):1,VADAT("F")=2:1,1:0):$P("JAN^FEB^MAR^APR^MAY^JUN^JUL^AUG^SEP^OCT^NOV^DEC","^",+$E(VA,4,5)),1:$E(VA,4,5)),VAY=$S(VA(3):(1700+$E(VA,1,3)),1:""),VAD=$S(VA(1)&$E(VA,6,7):$E(VA,6,7),1:"")
-	I $P(VA,".",2)]"" S VA=$P(VA,".",2),VAT=$E(VA_"000000",1,2)_":"_$E(VA_"000000",3,4) S:$D(VADAT("S")) VAT=VAT_":"_$E(VA_"000000",5,6)
-	I '$D(VADAT("F")) S VADATE("E")=VAM_$S(VAM]""&(VAD!VAY):" ",1:"")_$S(VAD:$J(+VAD,2),1:"")_$S(VAD&VAY:",",1:"")_VAY_$S($D(VAT):"@"_VAT,1:"") G QUIT
-	S VADEL=$S('$D(VADAT("D")):"-",1:VADAT("D")) I VADAT("F")=1 S VADATE("E")=$S('VA(2):"",VAM]"":VAM,1:"00")_$S(VA(1)&VA(2):VADEL,1:"")_$S('VA(1):"",VAD]"":VAD,1:"00")_$S((VA(1)!VA(2))&VA(3):VADEL,1:"")
-	I VADAT("F")=2 S VADATE("E")=$S('VA(1):"",VAD]"":VAD,1:"00")_$S(VA(1)&VA(2):VADEL,1:"")_$S('VA(2):"",VAM]"":VAM,1:"XXX")_$S((VA(1)!VA(2))&VA(3):VADEL,1:"")
-	S VADATE("E")=VADATE("E")_$S(VA(3):$E(VAY,3,4),1:"")_$S($D(VAT):"@"_VAT,1:"")
-QUIT	I $D(VADAT("J")),VADAT("J")?.N F I=$L(VADATE("E"))+1:1:VADAT("J") S VADATE("E")=" "_VADATE("E")
-	K %DT,VA,VAD,VADEL,VAM,VAT,VAX,VAY,VANOW Q
-KVAR	K VADAT,VADATE Q
+VADATE ;ALB/MLI - GENERIC DATE ROUTINE ; 1 DEC 88 @1000
+ ;;5.3;Registration;;Aug 13, 1993
+ ;
+ I $D(VADAT("F")),$S(VADAT("F")<1:1,VADAT("F")>2:1,1:0) K VADAT("F")
+ I '$D(VADAT("W")) D NOW^%DTC
+ S VA=$S('$D(VADAT("W")):%,1:VADAT("W")),(VA,VADATE("I"))=$S($D(VADAT("S")):VA,'$D(VADAT("T")):$E(VA,1,12),1:$P(VA,".",1))
+ S:'$D(VADAT("H")) (VA(1),VA(2),VA(3))=1 I $D(VADAT("H")) F I=1:1:3 S VA(I)=$S(VADAT("H")[I:1,1:0)
+ S VAM=$S('$E(VA,4,5):"",'VA(2):"",$S('$D(VADAT("F")):1,VADAT("F")=2:1,1:0):$P("JAN^FEB^MAR^APR^MAY^JUN^JUL^AUG^SEP^OCT^NOV^DEC","^",+$E(VA,4,5)),1:$E(VA,4,5)),VAY=$S(VA(3):(1700+$E(VA,1,3)),1:""),VAD=$S(VA(1)&$E(VA,6,7):$E(VA,6,7),1:"")
+ I $P(VA,".",2)]"" S VA=$P(VA,".",2),VAT=$E(VA_"000000",1,2)_":"_$E(VA_"000000",3,4) S:$D(VADAT("S")) VAT=VAT_":"_$E(VA_"000000",5,6)
+ I '$D(VADAT("F")) S VADATE("E")=VAM_$S(VAM]""&(VAD!VAY):" ",1:"")_$S(VAD:$J(+VAD,2),1:"")_$S(VAD&VAY:",",1:"")_VAY_$S($D(VAT):"@"_VAT,1:"") G QUIT
+ S VADEL=$S('$D(VADAT("D")):"-",1:VADAT("D")) I VADAT("F")=1 S VADATE("E")=$S('VA(2):"",VAM]"":VAM,1:"00")_$S(VA(1)&VA(2):VADEL,1:"")_$S('VA(1):"",VAD]"":VAD,1:"00")_$S((VA(1)!VA(2))&VA(3):VADEL,1:"")
+ I VADAT("F")=2 S VADATE("E")=$S('VA(1):"",VAD]"":VAD,1:"00")_$S(VA(1)&VA(2):VADEL,1:"")_$S('VA(2):"",VAM]"":VAM,1:"XXX")_$S((VA(1)!VA(2))&VA(3):VADEL,1:"")
+ S VADATE("E")=VADATE("E")_$S(VA(3):$E(VAY,3,4),1:"")_$S($D(VAT):"@"_VAT,1:"")
+QUIT I $D(VADAT("J")),VADAT("J")?.N F I=$L(VADATE("E"))+1:1:VADAT("J") S VADATE("E")=" "_VADATE("E")
+ K %DT,VA,VAD,VADEL,VAM,VAT,VAX,VAY Q
+KVAR K VADAT,VADATE Q
